/********** MEGA8 WINAVR **********/
/***********************************/
#define zaderjka 2000


#define getbit(x,y)((x&(1<<y)) ? 1:0)
#define sbi(PORT,PIN) (PORT)|=_BV(PIN)
#define cbi(PORT,PIN) (PORT)&=~_BV(PIN)
#define  outb(addr, data)   addr = (data) 
#define  inb(addr)   (addr)

#define F_CPU 8000000UL

#include <avr/io.h>
#include <avr/delay.h>
#include <avr/interrupt.h>


#define SENSOR_B1	getbit(PINC, 0)
#define SENSOR_B2	getbit(PINC, 1)
#define SENSOR_B3	getbit(PINC, 2)

#define PNEVMA_Y1_ENABLE	sbi(PORTD, 0)
#define PNEVMA_Y1_DISABLE	cbi(PORTD, 0)
#define PNEVMA_Y2_ENABLE	sbi(PORTD, 1)
#define PNEVMA_Y2_DISABLE	cbi(PORTD, 1)



unsigned char prog_counter = 0;

int main(void)
{
	
	PORTB = 0x01;
	DDRD = 0x83;
	
	
	while(1){
		
	
		if(!getbit(PINB, 0)) 
		{

			while(!getbit(PINB, 0));
			
			while(1)
			{
				
				_delay_ms(300);
				sbi(PORTB, 1);
				_delay_ms(300);
				cbi(PORTB, 1);
				
				
				switch(prog_counter)
				{
					case 0:
						if((SENSOR_B1 == 1) && (SENSOR_B2 && SENSOR_B3) == 0)
						{
							PNEVMA_Y1_ENABLE;
							prog_counter = 1;
						}
					break;
					
					case 1:
						if(SENSOR_B3 == 1)
						{
							_delay_ms(zaderjka);
							PNEVMA_Y2_ENABLE;
							prog_counter = 2;
						}
					break;
					
					case 2:
						if(SENSOR_B1 == 0 && SENSOR_B2 == 1)
						{
							_delay_ms(zaderjka);
							PNEVMA_Y2_DISABLE;
							prog_counter = 3;
						}
					break;
					
					case 3:
						if(SENSOR_B1 == 1 && SENSOR_B2 == 0)
						{
							_delay_ms(zaderjka);
							PNEVMA_Y1_DISABLE;
							prog_counter = 4;
						}
					break;
					
					case 4:
						if(SENSOR_B3 == 0)
						{
							prog_counter = 0;
							main();
						}
					break;
					
					
					
				}
			}
		}
	}
	
	
}

